#include <iostream>

using namespace std;

class Vehicle {
   protected:
    string brand;
    string licencePlate;
    int ps;
    int constructionYear;

   public:
    // default constructor
    Vehicle() {}

    // constructor with member initialization list
    Vehicle(string br, string licence, int ps, int cy) : brand(br), licencePlate(licence), ps(ps), constructionYear(cy) {}

    void displayData() {
        cout << "Brand: " << brand << endl;
        cout << "Licence Plate: " << licencePlate << endl;
        cout << "PS: " << ps << endl;
        cout << "Construction Year: " << constructionYear << endl;
    }

    void init(string b, string l, int p, int c) {
        brand = b;
        licencePlate = l;
        ps = p;
        constructionYear = c;
    }
};

class Car : public Vehicle {
   private:
    float maxSpeed;

   public:
    Car() {}
    Car(string br, string licence, int ps, int cy, float max) : Vehicle(br, licence, ps, cy), maxSpeed(max) {}

    void displayData() {
        Vehicle::displayData();
        cout << "Maximum Speed: " << maxSpeed << endl;
    }

    void init(string b, string l, int p, int c, float max) {
        Vehicle::init(b, l, p, c);
        maxSpeed = max;
    }
};

class Truck : public Vehicle {
   private:
    float maxLoad;
    int numberWheels;

   public:
    Truck() {}
    Truck(string br, string licence, int ps, int cy, float max, int no) : Vehicle(br, licence, ps, cy), maxLoad(max), numberWheels(no) {}

    void displayData() {
        Vehicle::displayData();
        cout << "Maximum Load: " << maxLoad << endl;
        cout << "Number of Wheels: " << numberWheels << endl;
    }

    void init(string b, string l, int p, int c, float max, int no) {
        Vehicle::init(b, l, p, c);
        maxLoad = max;
        numberWheels = no;
    }
};

int main() {
    Car car;
    Car *p1;
    p1 = &car;

    Truck truck;
    Truck *l1;
    l1 = &truck;

    p1->init("Opel", "KA WA 11", 78, 2004, 150);
    l1->init("Mercedes", "WA SS 44", 99, 2007, 5.4, 8);

    p1->displayData();
    l1->displayData();

    return 0;
};
